<?php

// Data functions (insert, update, delete, form) for table Riders

// This script and data application were generated by AppGini 23.14
// Download AppGini for free from https://bigprof.com/appgini/download/

function Riders_insert(&$error_message = '') {
	global $Translation;

	// mm: can member insert record?
	$arrPerm = getTablePermissions('Riders');
	if(!$arrPerm['insert']) return false;

	$data = [
		'name' => Request::val('name', ''),
		'ghana_card' => Request::fileUpload('ghana_card', [
			'maxSize' => 51200000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'success' => function($name, $selected_id) {
			},
			'failure' => function($selected_id, $fileRemoved) {
				if(!strlen(Request::val('SelectedID'))) return '';

				/* for empty upload fields, when saving a copy of an existing record, copy the original upload field */
				return existing_value('Riders', 'ghana_card', Request::val('SelectedID'));
			},
		]),
		'riders_license' => Request::fileUpload('riders_license', [
			'maxSize' => 51200000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'success' => function($name, $selected_id) {
			},
			'failure' => function($selected_id, $fileRemoved) {
				if(!strlen(Request::val('SelectedID'))) return '';

				/* for empty upload fields, when saving a copy of an existing record, copy the original upload field */
				return existing_value('Riders', 'riders_license', Request::val('SelectedID'));
			},
		]),
		'police_clearance' => Request::fileUpload('police_clearance', [
			'maxSize' => 51200000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'success' => function($name, $selected_id) {
			},
			'failure' => function($selected_id, $fileRemoved) {
				if(!strlen(Request::val('SelectedID'))) return '';

				/* for empty upload fields, when saving a copy of an existing record, copy the original upload field */
				return existing_value('Riders', 'police_clearance', Request::val('SelectedID'));
			},
		]),
		'location' => Request::val('location', ''),
		'educational_qualification' => Request::fileUpload('educational_qualification', [
			'maxSize' => 51200000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'success' => function($name, $selected_id) {
			},
			'failure' => function($selected_id, $fileRemoved) {
				if(!strlen(Request::val('SelectedID'))) return '';

				/* for empty upload fields, when saving a copy of an existing record, copy the original upload field */
				return existing_value('Riders', 'educational_qualification', Request::val('SelectedID'));
			},
		]),
		'passport_picture' => Request::fileUpload('passport_picture', [
			'maxSize' => 51200000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'success' => function($name, $selected_id) {
				createThumbnail($name, getThumbnailSpecs('Riders', 'passport_picture', 'tv'));
				createThumbnail($name, getThumbnailSpecs('Riders', 'passport_picture', 'dv'));
			},
			'failure' => function($selected_id, $fileRemoved) {
				if(!strlen(Request::val('SelectedID'))) return '';

				/* for empty upload fields, when saving a copy of an existing record, copy the original upload field */
				return existing_value('Riders', 'passport_picture', Request::val('SelectedID'));
			},
		]),
	];

	if($data['name'] === '') {
		echo StyleSheet() . "\n\n<div class=\"alert alert-danger\">{$Translation['error:']} 'Name': {$Translation['field not null']}<br><br>";
		echo '<a href="" onclick="history.go(-1); return false;">' . $Translation['< back'] . '</a></div>';
		exit;
	}
	if($data['ghana_card'] === '') {
		echo StyleSheet() . "\n\n<div class=\"alert alert-danger\">{$Translation['error:']} 'Ghana card': {$Translation['field not null']}<br><br>";
		echo '<a href="" onclick="history.go(-1); return false;">' . $Translation['< back'] . '</a></div>';
		exit;
	}
	if($data['riders_license'] === '') {
		echo StyleSheet() . "\n\n<div class=\"alert alert-danger\">{$Translation['error:']} 'Riders license': {$Translation['field not null']}<br><br>";
		echo '<a href="" onclick="history.go(-1); return false;">' . $Translation['< back'] . '</a></div>';
		exit;
	}
	if($data['location'] === '') {
		echo StyleSheet() . "\n\n<div class=\"alert alert-danger\">{$Translation['error:']} 'Location': {$Translation['field not null']}<br><br>";
		echo '<a href="" onclick="history.go(-1); return false;">' . $Translation['< back'] . '</a></div>';
		exit;
	}
	if($data['passport_picture'] === '') {
		echo StyleSheet() . "\n\n<div class=\"alert alert-danger\">{$Translation['error:']} 'Passport picture': {$Translation['field not null']}<br><br>";
		echo '<a href="" onclick="history.go(-1); return false;">' . $Translation['< back'] . '</a></div>';
		exit;
	}

	// hook: Riders_before_insert
	if(function_exists('Riders_before_insert')) {
		$args = [];
		if(!Riders_before_insert($data, getMemberInfo(), $args)) {
			if(isset($args['error_message'])) $error_message = $args['error_message'];
			return false;
		}
	}

	$error = '';
	// set empty fields to NULL
	$data = array_map(function($v) { return ($v === '' ? NULL : $v); }, $data);
	insert('Riders', backtick_keys_once($data), $error);
	if($error) {
		$error_message = $error;
		return false;
	}

	$recID = db_insert_id(db_link());

	update_calc_fields('Riders', $recID, calculated_fields()['Riders']);

	// hook: Riders_after_insert
	if(function_exists('Riders_after_insert')) {
		$res = sql("SELECT * FROM `Riders` WHERE `id`='" . makeSafe($recID, false) . "' LIMIT 1", $eo);
		if($row = db_fetch_assoc($res)) {
			$data = array_map('makeSafe', $row);
		}
		$data['selectedID'] = makeSafe($recID, false);
		$args = [];
		if(!Riders_after_insert($data, getMemberInfo(), $args)) { return $recID; }
	}

	// mm: save ownership data
	set_record_owner('Riders', $recID, getLoggedMemberID());

	// if this record is a copy of another record, copy children if applicable
	if(strlen(Request::val('SelectedID'))) Riders_copy_children($recID, Request::val('SelectedID'));

	return $recID;
}

function Riders_copy_children($destination_id, $source_id) {
	global $Translation;
	$requests = []; // array of curl handlers for launching insert requests
	$eo = ['silentErrors' => true];
	$safe_sid = makeSafe($source_id);

	// launch requests, asynchronously
	curl_batch($requests);
}

function Riders_delete($selected_id, $AllowDeleteOfParents = false, $skipChecks = false) {
	// insure referential integrity ...
	global $Translation;
	$selected_id = makeSafe($selected_id);

	// mm: can member delete record?
	if(!check_record_permission('Riders', $selected_id, 'delete')) {
		return $Translation['You don\'t have enough permissions to delete this record'];
	}

	// hook: Riders_before_delete
	if(function_exists('Riders_before_delete')) {
		$args = [];
		if(!Riders_before_delete($selected_id, $skipChecks, getMemberInfo(), $args))
			return $Translation['Couldn\'t delete this record'] . (
				!empty($args['error_message']) ?
					'<div class="text-bold">' . strip_tags($args['error_message']) . '</div>'
					: '' 
			);
	}

	sql("DELETE FROM `Riders` WHERE `id`='{$selected_id}'", $eo);

	// hook: Riders_after_delete
	if(function_exists('Riders_after_delete')) {
		$args = [];
		Riders_after_delete($selected_id, getMemberInfo(), $args);
	}

	// mm: delete ownership data
	sql("DELETE FROM `membership_userrecords` WHERE `tableName`='Riders' AND `pkValue`='{$selected_id}'", $eo);
}

function Riders_update(&$selected_id, &$error_message = '') {
	global $Translation;

	// mm: can member edit record?
	if(!check_record_permission('Riders', $selected_id, 'edit')) return false;

	$data = [
		'name' => Request::val('name', ''),
		'ghana_card' => Request::fileUpload('ghana_card', [
			'maxSize' => 51200000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'id' => $selected_id,
			'success' => function($name, $selected_id) {
			},
			'removeOnRequest' => false,
			'remove' => function($selected_id) {
				// do nothing: preserve removed files on server.
			},
			'failure' => function($selected_id, $fileRemoved) {
				if($fileRemoved) return '';
				return existing_value('Riders', 'ghana_card', $selected_id);
			},
		]),
		'riders_license' => Request::fileUpload('riders_license', [
			'maxSize' => 51200000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'id' => $selected_id,
			'success' => function($name, $selected_id) {
			},
			'removeOnRequest' => false,
			'remove' => function($selected_id) {
				// do nothing: preserve removed files on server.
			},
			'failure' => function($selected_id, $fileRemoved) {
				if($fileRemoved) return '';
				return existing_value('Riders', 'riders_license', $selected_id);
			},
		]),
		'police_clearance' => Request::fileUpload('police_clearance', [
			'maxSize' => 51200000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'id' => $selected_id,
			'success' => function($name, $selected_id) {
			},
			'removeOnRequest' => true,
			'remove' => function($selected_id) {
				// do nothing: preserve removed files on server.
			},
			'failure' => function($selected_id, $fileRemoved) {
				if($fileRemoved) return '';
				return existing_value('Riders', 'police_clearance', $selected_id);
			},
		]),
		'location' => Request::val('location', ''),
		'educational_qualification' => Request::fileUpload('educational_qualification', [
			'maxSize' => 51200000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'id' => $selected_id,
			'success' => function($name, $selected_id) {
			},
			'removeOnRequest' => true,
			'remove' => function($selected_id) {
				// do nothing: preserve removed files on server.
			},
			'failure' => function($selected_id, $fileRemoved) {
				if($fileRemoved) return '';
				return existing_value('Riders', 'educational_qualification', $selected_id);
			},
		]),
		'passport_picture' => Request::fileUpload('passport_picture', [
			'maxSize' => 51200000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'id' => $selected_id,
			'success' => function($name, $selected_id) {
				createThumbnail($name, getThumbnailSpecs('Riders', 'passport_picture', 'tv'));
				createThumbnail($name, getThumbnailSpecs('Riders', 'passport_picture', 'dv'));
			},
			'removeOnRequest' => false,
			'remove' => function($selected_id) {
				// do nothing: preserve removed files on server.
			},
			'failure' => function($selected_id, $fileRemoved) {
				if($fileRemoved) return '';
				return existing_value('Riders', 'passport_picture', $selected_id);
			},
		]),
	];

	if($data['name'] === '') {
		echo StyleSheet() . "\n\n<div class=\"alert alert-danger\">{$Translation['error:']} 'Name': {$Translation['field not null']}<br><br>";
		echo '<a href="" onclick="history.go(-1); return false;">' . $Translation['< back'] . '</a></div>';
		exit;
	}
	if($data['ghana_card'] === '') {
		echo StyleSheet() . "\n\n<div class=\"alert alert-danger\">{$Translation['error:']} 'Ghana card': {$Translation['field not null']}<br><br>";
		echo '<a href="" onclick="history.go(-1); return false;">' . $Translation['< back'] . '</a></div>';
		exit;
	}
	if($data['riders_license'] === '') {
		echo StyleSheet() . "\n\n<div class=\"alert alert-danger\">{$Translation['error:']} 'Riders license': {$Translation['field not null']}<br><br>";
		echo '<a href="" onclick="history.go(-1); return false;">' . $Translation['< back'] . '</a></div>';
		exit;
	}
	if($data['location'] === '') {
		echo StyleSheet() . "\n\n<div class=\"alert alert-danger\">{$Translation['error:']} 'Location': {$Translation['field not null']}<br><br>";
		echo '<a href="" onclick="history.go(-1); return false;">' . $Translation['< back'] . '</a></div>';
		exit;
	}
	if($data['passport_picture'] === '') {
		echo StyleSheet() . "\n\n<div class=\"alert alert-danger\">{$Translation['error:']} 'Passport picture': {$Translation['field not null']}<br><br>";
		echo '<a href="" onclick="history.go(-1); return false;">' . $Translation['< back'] . '</a></div>';
		exit;
	}
	// get existing values
	$old_data = getRecord('Riders', $selected_id);
	if(is_array($old_data)) {
		$old_data = array_map('makeSafe', $old_data);
		$old_data['selectedID'] = makeSafe($selected_id);
	}

	$data['selectedID'] = makeSafe($selected_id);

	// hook: Riders_before_update
	if(function_exists('Riders_before_update')) {
		$args = ['old_data' => $old_data];
		if(!Riders_before_update($data, getMemberInfo(), $args)) {
			if(isset($args['error_message'])) $error_message = $args['error_message'];
			return false;
		}
	}

	$set = $data; unset($set['selectedID']);
	foreach ($set as $field => $value) {
		$set[$field] = ($value !== '' && $value !== NULL) ? $value : NULL;
	}

	if(!update(
		'Riders', 
		backtick_keys_once($set), 
		['`id`' => $selected_id], 
		$error_message
	)) {
		echo $error_message;
		echo '<a href="Riders_view.php?SelectedID=' . urlencode($selected_id) . "\">{$Translation['< back']}</a>";
		exit;
	}


	$eo = ['silentErrors' => true];

	update_calc_fields('Riders', $data['selectedID'], calculated_fields()['Riders']);

	// hook: Riders_after_update
	if(function_exists('Riders_after_update')) {
		$res = sql("SELECT * FROM `Riders` WHERE `id`='{$data['selectedID']}' LIMIT 1", $eo);
		if($row = db_fetch_assoc($res)) $data = array_map('makeSafe', $row);

		$data['selectedID'] = $data['id'];
		$args = ['old_data' => $old_data];
		if(!Riders_after_update($data, getMemberInfo(), $args)) return;
	}

	// mm: update ownership data
	sql("UPDATE `membership_userrecords` SET `dateUpdated`='" . time() . "' WHERE `tableName`='Riders' AND `pkValue`='" . makeSafe($selected_id) . "'", $eo);
}

function Riders_form($selected_id = '', $AllowUpdate = 1, $AllowInsert = 1, $AllowDelete = 1, $separateDV = 0, $TemplateDV = '', $TemplateDVP = '') {
	// function to return an editable form for a table records
	// and fill it with data of record whose ID is $selected_id. If $selected_id
	// is empty, an empty form is shown, with only an 'Add New'
	// button displayed.

	global $Translation;
	$eo = ['silentErrors' => true];
	$noUploads = null;
	$row = $urow = $jsReadOnly = $jsEditable = $lookups = null;

	$noSaveAsCopy = false;

	// mm: get table permissions
	$arrPerm = getTablePermissions('Riders');
	if(!$arrPerm['insert'] && $selected_id == '')
		// no insert permission and no record selected
		// so show access denied error unless TVDV
		return $separateDV ? $Translation['tableAccessDenied'] : '';
	$AllowInsert = ($arrPerm['insert'] ? true : false);
	// print preview?
	$dvprint = false;
	if(strlen($selected_id) && Request::val('dvprint_x') != '') {
		$dvprint = true;
	}


	// populate filterers, starting from children to grand-parents

	// unique random identifier
	$rnd1 = ($dvprint ? rand(1000000, 9999999) : '');

	if($selected_id) {
		if(!check_record_permission('Riders', $selected_id, 'view'))
			return $Translation['tableAccessDenied'];

		// can edit?
		$AllowUpdate = check_record_permission('Riders', $selected_id, 'edit');

		// can delete?
		$AllowDelete = check_record_permission('Riders', $selected_id, 'delete');

		$res = sql("SELECT * FROM `Riders` WHERE `id`='" . makeSafe($selected_id) . "'", $eo);
		if(!($row = db_fetch_array($res))) {
			return error_message($Translation['No records found'], 'Riders_view.php', false);
		}
		$urow = $row; /* unsanitized data */
		$row = array_map('safe_html', $row);
	} else {
		$filterField = Request::val('FilterField');
		$filterOperator = Request::val('FilterOperator');
		$filterValue = Request::val('FilterValue');
	}

	// code for template based detail view forms

	// open the detail view template
	if($dvprint) {
		$template_file = is_file("./{$TemplateDVP}") ? "./{$TemplateDVP}" : './templates/Riders_templateDVP.html';
		$templateCode = @file_get_contents($template_file);
	} else {
		$template_file = is_file("./{$TemplateDV}") ? "./{$TemplateDV}" : './templates/Riders_templateDV.html';
		$templateCode = @file_get_contents($template_file);
	}

	// process form title
	$templateCode = str_replace('<%%DETAIL_VIEW_TITLE%%>', 'Rider details', $templateCode);
	$templateCode = str_replace('<%%RND1%%>', $rnd1, $templateCode);
	$templateCode = str_replace('<%%EMBEDDED%%>', (Request::val('Embedded') ? 'Embedded=1' : ''), $templateCode);
	// process buttons
	if($AllowInsert) {
		if(!$selected_id) $templateCode = str_replace('<%%INSERT_BUTTON%%>', '<button type="submit" class="btn btn-success" id="insert" name="insert_x" value="1" onclick="return Riders_validateData();"><i class="glyphicon glyphicon-plus-sign"></i> ' . $Translation['Save New'] . '</button>', $templateCode);
		$templateCode = str_replace('<%%INSERT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="insert" name="insert_x" value="1" onclick="return Riders_validateData();"><i class="glyphicon glyphicon-plus-sign"></i> ' . $Translation['Save As Copy'] . '</button>', $templateCode);
	} else {
		$templateCode = str_replace('<%%INSERT_BUTTON%%>', '', $templateCode);
	}

	// 'Back' button action
	if(Request::val('Embedded')) {
		$backAction = 'AppGini.closeParentModal(); return false;';
	} else {
		$backAction = '$j(\'form\').eq(0).attr(\'novalidate\', \'novalidate\'); document.myform.reset(); return true;';
	}

	if($selected_id) {
		if(!Request::val('Embedded')) $templateCode = str_replace('<%%DVPRINT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="dvprint" name="dvprint_x" value="1" onclick="$j(\'form\').eq(0).prop(\'novalidate\', true); document.myform.reset(); return true;" title="' . html_attr($Translation['Print Preview']) . '"><i class="glyphicon glyphicon-print"></i> ' . $Translation['Print Preview'] . '</button>', $templateCode);
		if($AllowUpdate)
			$templateCode = str_replace('<%%UPDATE_BUTTON%%>', '<button type="submit" class="btn btn-success btn-lg" id="update" name="update_x" value="1" onclick="return Riders_validateData();" title="' . html_attr($Translation['Save Changes']) . '"><i class="glyphicon glyphicon-ok"></i> ' . $Translation['Save Changes'] . '</button>', $templateCode);
		else
			$templateCode = str_replace('<%%UPDATE_BUTTON%%>', '', $templateCode);

		if($AllowDelete)
			$templateCode = str_replace('<%%DELETE_BUTTON%%>', '<button type="submit" class="btn btn-danger" id="delete" name="delete_x" value="1" title="' . html_attr($Translation['Delete']) . '"><i class="glyphicon glyphicon-trash"></i> ' . $Translation['Delete'] . '</button>', $templateCode);
		else
			$templateCode = str_replace('<%%DELETE_BUTTON%%>', '', $templateCode);

		$templateCode = str_replace('<%%DESELECT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="deselect" name="deselect_x" value="1" onclick="' . $backAction . '" title="' . html_attr($Translation['Back']) . '"><i class="glyphicon glyphicon-chevron-left"></i> ' . $Translation['Back'] . '</button>', $templateCode);
	} else {
		$templateCode = str_replace('<%%UPDATE_BUTTON%%>', '', $templateCode);
		$templateCode = str_replace('<%%DELETE_BUTTON%%>', '', $templateCode);

		// if not in embedded mode and user has insert only but no view/update/delete,
		// remove 'back' button
		if(
			$arrPerm['insert']
			&& !$arrPerm['update'] && !$arrPerm['delete'] && !$arrPerm['view']
			&& !Request::val('Embedded')
		)
			$templateCode = str_replace('<%%DESELECT_BUTTON%%>', '', $templateCode);
		elseif($separateDV)
			$templateCode = str_replace(
				'<%%DESELECT_BUTTON%%>', 
				'<button
					type="submit" 
					class="btn btn-default" 
					id="deselect" 
					name="deselect_x" 
					value="1" 
					onclick="' . $backAction . '" 
					title="' . html_attr($Translation['Back']) . '">
						<i class="glyphicon glyphicon-chevron-left"></i> ' .
						$Translation['Back'] .
				'</button>',
				$templateCode
			);
		else
			$templateCode = str_replace('<%%DESELECT_BUTTON%%>', '', $templateCode);
	}

	// set records to read only if user can't insert new records and can't edit current record
	if(($selected_id && !$AllowUpdate && !$AllowInsert) || (!$selected_id && !$AllowInsert)) {
		$jsReadOnly = '';
		$jsReadOnly .= "\tjQuery('#name').replaceWith('<div class=\"form-control-static\" id=\"name\">' + (jQuery('#name').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#ghana_card').replaceWith('<div class=\"form-control-static\" id=\"ghana_card\">' + (jQuery('#ghana_card').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#ghana_card, #ghana_card-edit-link').hide();\n";
		$jsReadOnly .= "\tjQuery('#riders_license').replaceWith('<div class=\"form-control-static\" id=\"riders_license\">' + (jQuery('#riders_license').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#riders_license, #riders_license-edit-link').hide();\n";
		$jsReadOnly .= "\tjQuery('#police_clearance').replaceWith('<div class=\"form-control-static\" id=\"police_clearance\">' + (jQuery('#police_clearance').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#police_clearance, #police_clearance-edit-link').hide();\n";
		$jsReadOnly .= "\tjQuery('#location').replaceWith('<div class=\"form-control-static\" id=\"location\">' + (jQuery('#location').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#educational_qualification').replaceWith('<div class=\"form-control-static\" id=\"educational_qualification\">' + (jQuery('#educational_qualification').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#educational_qualification, #educational_qualification-edit-link').hide();\n";
		$jsReadOnly .= "\tjQuery('#passport_picture').replaceWith('<div class=\"form-control-static\" id=\"passport_picture\">' + (jQuery('#passport_picture').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('.select2-container').hide();\n";

		$noUploads = true;
	} elseif($AllowInsert) {
		$jsEditable = "\tjQuery('form').eq(0).data('already_changed', true);"; // temporarily disable form change handler
		$jsEditable .= "\tjQuery('form').eq(0).data('already_changed', false);"; // re-enable form change handler
	}

	// process combos

	/* lookup fields array: 'lookup field name' => ['parent table name', 'lookup field caption'] */
	$lookup_fields = [];
	foreach($lookup_fields as $luf => $ptfc) {
		$pt_perm = getTablePermissions($ptfc[0]);

		// process foreign key links
		if($pt_perm['view'] || $pt_perm['edit']) {
			$templateCode = str_replace("<%%PLINK({$luf})%%>", '<button type="button" class="btn btn-default view_parent" id="' . $ptfc[0] . '_view_parent" title="' . html_attr($Translation['View'] . ' ' . $ptfc[1]) . '"><i class="glyphicon glyphicon-eye-open"></i></button>', $templateCode);
		}

		// if user has insert permission to parent table of a lookup field, put an add new button
		if($pt_perm['insert'] /* && !Request::val('Embedded')*/) {
			$templateCode = str_replace("<%%ADDNEW({$ptfc[0]})%%>", '<button type="button" class="btn btn-default add_new_parent" id="' . $ptfc[0] . '_add_new" title="' . html_attr($Translation['Add New'] . ' ' . $ptfc[1]) . '"><i class="glyphicon glyphicon-plus text-success"></i></button>', $templateCode);
		}
	}

	// process images
	$templateCode = str_replace('<%%UPLOADFILE(id)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(name)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(ghana_card)%%>', ($noUploads ? '' : "<div>{$Translation['upload image']}</div>" . '<input type="file" name="ghana_card" id="ghana_card" data-filetypes="jpg|jpeg|gif|png|webp" data-maxsize="51200000" style="max-width: calc(100% - 1.5rem);" accept=".jpg,.jpeg,.gif,.png,.webp">' . '<i class="text-danger clear-upload hidden pull-right" style="margin-top: -.1em; font-size: large;">&times;</i>'), $templateCode);
	if($AllowUpdate && $row['ghana_card'] != '') {
		$templateCode = str_replace('<%%REMOVEFILE(ghana_card)%%>', '<input type="checkbox" name="ghana_card_remove" id="ghana_card_remove" value="1"> <label for="ghana_card_remove" style="color: red; font-weight: bold;">'.$Translation['remove image'].'</label>', $templateCode);
	} else {
		$templateCode = str_replace('<%%REMOVEFILE(ghana_card)%%>', '', $templateCode);
	}
	$templateCode = str_replace('<%%UPLOADFILE(riders_license)%%>', ($noUploads ? '' : "<div>{$Translation['upload image']}</div>" . '<input type="file" name="riders_license" id="riders_license" data-filetypes="jpg|jpeg|gif|png|webp" data-maxsize="51200000" style="max-width: calc(100% - 1.5rem);" accept=".jpg,.jpeg,.gif,.png,.webp">' . '<i class="text-danger clear-upload hidden pull-right" style="margin-top: -.1em; font-size: large;">&times;</i>'), $templateCode);
	if($AllowUpdate && $row['riders_license'] != '') {
		$templateCode = str_replace('<%%REMOVEFILE(riders_license)%%>', '<input type="checkbox" name="riders_license_remove" id="riders_license_remove" value="1"> <label for="riders_license_remove" style="color: red; font-weight: bold;">'.$Translation['remove image'].'</label>', $templateCode);
	} else {
		$templateCode = str_replace('<%%REMOVEFILE(riders_license)%%>', '', $templateCode);
	}
	$templateCode = str_replace('<%%UPLOADFILE(police_clearance)%%>', ($noUploads ? '' : "<div>{$Translation['upload image']}</div>" . '<input type="file" name="police_clearance" id="police_clearance" data-filetypes="jpg|jpeg|gif|png|webp" data-maxsize="51200000" style="max-width: calc(100% - 1.5rem);" accept=".jpg,.jpeg,.gif,.png,.webp">' . '<i class="text-danger clear-upload hidden pull-right" style="margin-top: -.1em; font-size: large;">&times;</i>'), $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(location)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(educational_qualification)%%>', ($noUploads ? '' : "<div>{$Translation['upload image']}</div>" . '<input type="file" name="educational_qualification" id="educational_qualification" data-filetypes="jpg|jpeg|gif|png|webp" data-maxsize="51200000" style="max-width: calc(100% - 1.5rem);" accept=".jpg,.jpeg,.gif,.png,.webp">' . '<i class="text-danger clear-upload hidden pull-right" style="margin-top: -.1em; font-size: large;">&times;</i>'), $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(passport_picture)%%>', ($noUploads ? '' : "<div>{$Translation['upload image']}</div>" . '<input type="file" name="passport_picture" id="passport_picture" data-filetypes="jpg|jpeg|gif|png|webp" data-maxsize="51200000" style="max-width: calc(100% - 1.5rem);" accept="capture=camera,image/*">' . '<i class="text-danger clear-upload hidden pull-right" style="margin-top: -.1em; font-size: large;">&times;</i>'), $templateCode);
	if($AllowUpdate && $row['passport_picture'] != '') {
		$templateCode = str_replace('<%%REMOVEFILE(passport_picture)%%>', '<input type="checkbox" name="passport_picture_remove" id="passport_picture_remove" value="1"> <label for="passport_picture_remove" style="color: red; font-weight: bold;">'.$Translation['remove image'].'</label>', $templateCode);
	} else {
		$templateCode = str_replace('<%%REMOVEFILE(passport_picture)%%>', '', $templateCode);
	}

	// process values
	if($selected_id) {
		if( $dvprint) $templateCode = str_replace('<%%VALUE(id)%%>', safe_html($urow['id']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(id)%%>', html_attr($row['id']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(id)%%>', urlencode($urow['id']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(name)%%>', safe_html($urow['name']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(name)%%>', html_attr($row['name']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(name)%%>', urlencode($urow['name']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(ghana_card)%%>', safe_html($urow['ghana_card']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(ghana_card)%%>', html_attr($row['ghana_card']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(ghana_card)%%>', urlencode($urow['ghana_card']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(riders_license)%%>', safe_html($urow['riders_license']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(riders_license)%%>', html_attr($row['riders_license']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(riders_license)%%>', urlencode($urow['riders_license']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(police_clearance)%%>', safe_html($urow['police_clearance']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(police_clearance)%%>', html_attr($row['police_clearance']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(police_clearance)%%>', urlencode($urow['police_clearance']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(location)%%>', safe_html($urow['location']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(location)%%>', html_attr($row['location']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(location)%%>', urlencode($urow['location']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(educational_qualification)%%>', safe_html($urow['educational_qualification']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(educational_qualification)%%>', html_attr($row['educational_qualification']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(educational_qualification)%%>', urlencode($urow['educational_qualification']), $templateCode);
		$row['passport_picture'] = ($row['passport_picture'] != '' ? $row['passport_picture'] : 'blank.gif');
		if( $dvprint) $templateCode = str_replace('<%%VALUE(passport_picture)%%>', safe_html($urow['passport_picture']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(passport_picture)%%>', html_attr($row['passport_picture']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(passport_picture)%%>', urlencode($urow['passport_picture']), $templateCode);
	} else {
		$templateCode = str_replace('<%%VALUE(id)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(id)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(name)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(name)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(ghana_card)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(ghana_card)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(riders_license)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(riders_license)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(police_clearance)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(police_clearance)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(location)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(location)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(educational_qualification)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(educational_qualification)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(passport_picture)%%>', 'blank.gif', $templateCode);
	}

	// process translations
	$templateCode = parseTemplate($templateCode);

	// clear scrap
	$templateCode = str_replace('<%%', '<!-- ', $templateCode);
	$templateCode = str_replace('%%>', ' -->', $templateCode);

	// hide links to inaccessible tables
	if(Request::val('dvprint_x') == '') {
		$templateCode .= "\n\n<script>\$j(function() {\n";
		$arrTables = getTableList();
		foreach($arrTables as $name => $caption) {
			$templateCode .= "\t\$j('#{$name}_link').removeClass('hidden');\n";
			$templateCode .= "\t\$j('#xs_{$name}_link').removeClass('hidden');\n";
		}

		$templateCode .= $jsReadOnly;
		$templateCode .= $jsEditable;

		if(!$selected_id) {
			$templateCode.="\n\tif(document.getElementById('ghana_cardEdit')) { document.getElementById('ghana_cardEdit').style.display='inline'; }";
			$templateCode.="\n\tif(document.getElementById('ghana_cardEditLink')) { document.getElementById('ghana_cardEditLink').style.display='none'; }";
			$templateCode.="\n\tif(document.getElementById('riders_licenseEdit')) { document.getElementById('riders_licenseEdit').style.display='inline'; }";
			$templateCode.="\n\tif(document.getElementById('riders_licenseEditLink')) { document.getElementById('riders_licenseEditLink').style.display='none'; }";
			$templateCode.="\n\tif(document.getElementById('police_clearanceEdit')) { document.getElementById('police_clearanceEdit').style.display='inline'; }";
			$templateCode.="\n\tif(document.getElementById('police_clearanceEditLink')) { document.getElementById('police_clearanceEditLink').style.display='none'; }";
			$templateCode.="\n\tif(document.getElementById('educational_qualificationEdit')) { document.getElementById('educational_qualificationEdit').style.display='inline'; }";
			$templateCode.="\n\tif(document.getElementById('educational_qualificationEditLink')) { document.getElementById('educational_qualificationEditLink').style.display='none'; }";
		}

		$templateCode.="\n});</script>\n";
	}

	// ajaxed auto-fill fields
	$templateCode .= '<script>';
	$templateCode .= '$j(function() {';


	$templateCode.="});";
	$templateCode.="</script>";
	$templateCode .= $lookups;

	// handle enforced parent values for read-only lookup fields
	$filterField = Request::val('FilterField');
	$filterOperator = Request::val('FilterOperator');
	$filterValue = Request::val('FilterValue');

	// don't include blank images in lightbox gallery
	$templateCode = preg_replace('/blank.gif" data-lightbox=".*?"/', 'blank.gif"', $templateCode);

	// don't display empty email links
	$templateCode=preg_replace('/<a .*?href="mailto:".*?<\/a>/', '', $templateCode);

	/* default field values */
	$rdata = $jdata = get_defaults('Riders');
	if($selected_id) {
		$jdata = get_joined_record('Riders', $selected_id);
		if($jdata === false) $jdata = get_defaults('Riders');
		$rdata = $row;
	}
	$templateCode .= loadView('Riders-ajax-cache', ['rdata' => $rdata, 'jdata' => $jdata]);

	// hook: Riders_dv
	if(function_exists('Riders_dv')) {
		$args = [];
		Riders_dv(($selected_id ? $selected_id : FALSE), getMemberInfo(), $templateCode, $args);
	}

	return $templateCode;
}